PF-build.sh 51 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.1.0-Build_39
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. #### Start check if OSTYPE is supported
  144. OS_FOUND=$( command -v uname)
  145. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  146. linux*)
  147. TARGET_OS="linux"
  148. ;;
  149. msys*|cygwin*|mingw*)
  150. # or possible 'bash on windows'
  151. TARGET_OS='windows'
  152. ;;
  153. nt|win*)
  154. TARGET_OS='windows'
  155. ;;
  156. *)
  157. TARGET_OS='unknown'
  158. ;;
  159. esac
  160. # Windows
  161. if [ $TARGET_OS == "windows" ]; then
  162. if [ $(uname -m) == "x86_64" ]; then
  163. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  164. Processor="64"
  165. elif [ $(uname -m) == "i386" ]; then
  166. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  167. Processor="32"
  168. else
  169. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  170. echo "Please refer to the notes of build.sh$(tput sgr0)"
  171. exit 1
  172. fi
  173. # Linux
  174. elif [ $TARGET_OS == "linux" ]; then
  175. if [ $(uname -m) == "x86_64" ]; then
  176. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  177. Processor="64"
  178. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  179. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  180. Processor="32"
  181. else
  182. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  183. echo "Please refer to the notes of build.sh$(tput sgr0)"
  184. exit 1
  185. fi
  186. else
  187. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  188. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  189. echo "Read the notes of build.sh$(tput sgr0)"
  190. exit 1
  191. fi
  192. sleep 2
  193. #### End check if OSTYPE is supported
  194. #### Prepare bash environment and check if wget, zip and other needed things are available
  195. # Check wget
  196. if ! type wget > /dev/null; then
  197. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  198. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  199. exit 2
  200. fi
  201. # Check for zip
  202. if ! type zip > /dev/null; then
  203. if [ $TARGET_OS == "windows" ]; then
  204. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  205. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  206. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  207. echo "Run git Bash under Administrator privilege and"
  208. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  209. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  210. exit 3
  211. elif [ $TARGET_OS == "linux" ]; then
  212. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  213. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  214. #sudo apt-get update && apt-get install zip
  215. exit 3
  216. fi
  217. fi
  218. # Check python ... needed during language build
  219. if ! type python > /dev/null; then
  220. if [ $TARGET_OS == "windows" ]; then
  221. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  222. exit 4
  223. elif [ $TARGET_OS == "linux" ]; then
  224. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  225. echo "As Python 2.x will not be maintained from 2020 please,"
  226. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  227. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  228. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  229. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  230. exit 4
  231. fi
  232. fi
  233. # Check gawk ... needed during language build
  234. if ! type gawk > /dev/null; then
  235. if [ $TARGET_OS == "linux" ]; then
  236. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  237. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  238. #sudo apt-get update && apt-get install gawk
  239. exit 5
  240. fi
  241. fi
  242. #### End prepare bash / Linux environment
  243. #### Set build environment
  244. ARDUINO_ENV="1.8.5"
  245. BUILD_ENV="1.0.6"
  246. BOARD="prusa_einsy_rambo"
  247. BOARD_PACKAGE_NAME="PrusaResearch"
  248. BOARD_VERSION="1.0.3"
  249. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  250. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  251. BOARD_FILENAME="prusa3dboards"
  252. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  253. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  254. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  255. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  256. LIB="PrusaLibrary"
  257. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  258. # List few useful data
  259. echo
  260. echo "Script path :" $SCRIPT_PATH
  261. echo "OS :" $OS
  262. echo "OS type :" $TARGET_OS
  263. echo ""
  264. echo "Arduino IDE :" $ARDUINO_ENV
  265. echo "Build env :" $BUILD_ENV
  266. echo "Board :" $BOARD
  267. echo "Package name:" $BOARD_PACKAGE_NAME
  268. echo "Board v. :" $BOARD_VERSION
  269. echo "Specific Lib:" $LIB
  270. echo ""
  271. #### Start prepare building environment
  272. #Check if build exists and creates it if not
  273. if [ ! -d "../PF-build-dl" ]; then
  274. mkdir ../PF-build-dl || exit 6
  275. fi
  276. cd ../PF-build-dl || exit 7
  277. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  278. # Check if PF-build-env-<version> exists and downloads + creates it if not
  279. # The build environment is based on the supported Arduino IDE portable version with some changes
  280. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  281. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  282. mkdir ../PF-build-env-$BUILD_ENV
  283. sleep 5
  284. fi
  285. # Download and extract supported Arduino IDE depending on OS
  286. # Windows
  287. if [ $TARGET_OS == "windows" ]; then
  288. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  289. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  290. sleep 2
  291. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  292. echo "$(tput sgr 0)"
  293. fi
  294. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  295. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  296. sleep 2
  297. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 8
  298. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  299. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  300. echo "$(tput sgr0)"
  301. fi
  302. fi
  303. # Linux
  304. if [ $TARGET_OS == "linux" ]; then
  305. # 32 or 64 bit version
  306. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  307. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  308. sleep 2
  309. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  310. echo "$(tput sgr 0)"
  311. fi
  312. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  313. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  314. sleep 2
  315. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  316. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  317. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  318. echo "$(tput sgr0)"
  319. fi
  320. fi
  321. # Make Arduino IDE portable
  322. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  323. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  324. fi
  325. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  326. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  327. fi
  328. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  329. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  330. fi
  331. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  332. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  333. fi
  334. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  335. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  336. fi
  337. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  338. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  339. fi
  340. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  341. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  342. fi
  343. # Change Arduino IDE preferences
  344. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  345. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  346. sleep 2
  347. echo "update.check"
  348. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  349. echo "board"
  350. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  351. echo "editor.linenumbers"
  352. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  353. echo "boardsmanager.additional.urls"
  354. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  355. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  356. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  357. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  358. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  359. echo "$(tput sgr0)"
  360. fi
  361. # Download and extract Prusa Firmware related parts
  362. # Download and extract PrusaResearchRambo board
  363. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  364. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  365. sleep 2
  366. wget $BOARD_FILE_URL || exit 9
  367. fi
  368. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  369. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  370. sleep 2
  371. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  372. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  373. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  374. fi
  375. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  376. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  377. fi
  378. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  379. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  380. fi
  381. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  382. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  383. fi
  384. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  385. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  386. echo "$(tput sgr 0)"
  387. fi
  388. # Download and extract Prusa Firmware specific library files
  389. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  390. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  391. sleep 2
  392. wget $PF_BUILD_FILE_URL || exit 11
  393. echo "$(tput sgr 0)"
  394. fi
  395. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  396. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  397. sleep 2
  398. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  399. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  400. echo "$(tput sgr0)"
  401. fi
  402. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  403. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  404. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  405. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  406. sleep 2
  407. fi
  408. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  409. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  410. sleep 2
  411. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  412. sleep 2
  413. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  414. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  415. echo "$(tput sgr0)"
  416. fi
  417. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  418. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  419. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  420. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  421. sleep 2
  422. echo "$(tput sgr0)"
  423. exit 13
  424. fi
  425. #### End prepare building
  426. #### Start
  427. cd $SCRIPT_PATH
  428. # Check if git is available
  429. if type git > /dev/null; then
  430. git_available="1"
  431. fi
  432. while getopts v:l:d:b:o:c:p:n:m:g:?h flag
  433. do
  434. case "${flag}" in
  435. v) variant_flag=${OPTARG};;
  436. l) language_flag=${OPTARG};;
  437. d) devel_flag=${OPTARG};;
  438. b) build_flag=${OPTARG};;
  439. o) output_flag=${OPTARG};;
  440. c) clean_flag=${OPTARG};;
  441. p) prusa_flag=${OPTARG};;
  442. n) new_build_flag=${OPTARG};;
  443. m) mk404_flag=${OPTARG};;
  444. g) graphics_flag=${OPTARG};;
  445. ?) help_flag=1;;
  446. h) help_flag=1;;
  447. esac
  448. done
  449. #echo "variant_flag: $variant_flag";
  450. #echo "language_flag: $language_flag";
  451. #echo "devel_flag: $devel_flag";
  452. #echo "build_flag: $build_flag";
  453. #echo "output_flag: $output_flag";
  454. #echo "help_flag: $help_flag"
  455. #echo "clean_flag: $clean_flag"
  456. #echo "prusa_flag: $prusa_flag"
  457. #echo "new_build_flag: $new_build_flag"
  458. #
  459. # '?' 'h' argument usage and help
  460. if [ "$help_flag" == "1" ] ; then
  461. echo "***************************************"
  462. echo "* PF-build.sh Version: 1.0.6-Build_33 *"
  463. echo "***************************************"
  464. echo "Arguments:"
  465. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  466. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  467. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  468. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  469. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  470. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  471. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  472. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  473. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  474. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  475. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  476. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  477. echo
  478. echo "Brief USAGE:"
  479. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n] [-m] [-g]"
  480. echo
  481. echo "Example:"
  482. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  483. echo " Will build all variants as multi language and final GOLD version"
  484. echo
  485. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  486. echo " Will build MK3S multi language final GOLD firmware "
  487. echo " with current commit count number and output extra information,"
  488. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  489. echo
  490. exit 14
  491. fi
  492. #
  493. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  494. if [ -z "$variant_flag" ] ; then
  495. # Select which variant of the Prusa Firmware will be compiled, like
  496. PS3="Select a variant: "
  497. while IFS= read -r -d $'\0' f; do
  498. options[i++]="$f"
  499. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  500. select opt in "${options[@]}" "All" "Quit"; do
  501. case $opt in
  502. *.h)
  503. VARIANT=$(basename "$opt" ".h")
  504. VARIANTS[i++]="$opt"
  505. break
  506. ;;
  507. "All")
  508. VARIANT="All"
  509. VARIANTS=${options[*]}
  510. break
  511. ;;
  512. "Quit")
  513. echo "You chose to stop"
  514. exit 20
  515. ;;
  516. *)
  517. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  518. ;;
  519. esac
  520. done
  521. else
  522. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  523. VARIANTS=$variant_flag
  524. elif [ "$variant_flag" == "All" ] ; then
  525. while IFS= read -r -d $'\0' f; do
  526. options[i++]="$f"
  527. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  528. VARIANT="All"
  529. VARIANTS=${options[*]}
  530. else
  531. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  532. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  533. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  534. echo "$(tput sgr0)"
  535. exit 21
  536. fi
  537. fi
  538. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  539. #Check default language mode
  540. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  541. if [ -z "$language_flag" ] ; then
  542. PS3="Select a language: "
  543. echo
  544. echo "Which lang-build do you want?"
  545. select yn in "Multi languages" "English only"; do
  546. case $yn in
  547. "Multi languages")
  548. LANGUAGES="ALL"
  549. break
  550. ;;
  551. "English only")
  552. LANGUAGES="EN_ONLY"
  553. break
  554. ;;
  555. *)
  556. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  557. ;;
  558. esac
  559. done
  560. else
  561. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  562. LANGUAGES=$language_flag
  563. else
  564. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  565. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  566. exit 22
  567. fi
  568. fi
  569. #Check if DEV_STATUS is selected via argument '-d'
  570. if [ ! -z "$devel_flag" ] ; then
  571. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  572. DEV_STATUS_SELECTED=$devel_flag
  573. else
  574. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  575. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  576. exit 23
  577. fi
  578. fi
  579. #Check if Build is selected via argument '-b'
  580. if [ ! -z "$build_flag" ] ; then
  581. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  582. echo "Build changed to $build_flag"
  583. BUILD=$(git rev-list --count HEAD)
  584. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  585. BUILD=$build_flag
  586. else
  587. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  588. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  589. exit 24
  590. fi
  591. echo "New Build number is: $BUILD"
  592. fi
  593. # check if script has been started with arguments
  594. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  595. OUTPUT=1
  596. else
  597. OUTPUT=0
  598. fi
  599. #echo "Output is:" $OUTPUT
  600. #Check git branch has changed
  601. if [ ! -z "git_available" ]; then
  602. BRANCH=""
  603. CLEAN_PF_FW_BUILD=0
  604. else
  605. BRANCH=$(git branch --show-current)
  606. echo "Current branch is:" $BRANCH
  607. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  608. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  609. echo "created PF-build.branch file"
  610. else
  611. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  612. echo "Previous branch was:" $PRE_BRANCH
  613. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  614. CLEAN_PF_FW_BUILD=1
  615. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  616. fi
  617. fi
  618. fi
  619. #Set BUILD_ENV_PATH
  620. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
  621. BUILD_ENV_PATH="$( pwd -P )"
  622. cd ../..
  623. #Checkif BUILD_PATH exists and if not creates it
  624. if [ ! -d "Prusa-Firmware-build" ]; then
  625. mkdir Prusa-Firmware-build || exit 26
  626. fi
  627. #Set the BUILD_PATH for Arduino IDE
  628. cd Prusa-Firmware-build || exit 27
  629. BUILD_PATH="$( pwd -P )"
  630. #Check git branch has changed
  631. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  632. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  633. rm -r *
  634. else
  635. echo "Nothing to clean up"
  636. fi
  637. for v in ${VARIANTS[*]}
  638. do
  639. VARIANT=$(basename "$v" ".h")
  640. PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  641. # Find firmware version in Configuration.h file and use it to generate the hex filename
  642. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  643. if [ -z "$BUILD" ] ; then
  644. # Find build version in Configuration.h file and use it to generate the hex filename
  645. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  646. else
  647. # Find and replace build version in Configuration.h file
  648. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  649. echo "Original build number: $BUILD_ORG"
  650. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  651. fi
  652. # Check if the motherboard is an EINSY and if so only one hex file will generated
  653. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  654. # Check development status
  655. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  656. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  657. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  658. DEV_STATUS="RC"
  659. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  660. DEV_STATUS="ALPHA"
  661. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  662. DEV_STATUS="BETA"
  663. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  664. DEV_STATUS="DEVEL"
  665. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  666. DEV_STATUS="DEBUG"
  667. else
  668. DEV_STATUS="UNKNOWN"
  669. echo
  670. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  671. PS3="Select YES only if source code is tested and trusted: "
  672. select yn in "Yes" "No"; do
  673. case $yn in
  674. Yes)
  675. DEV_STATUS="GOLD"
  676. DEV_STATUS_SELECTED="GOLD"
  677. break
  678. ;;
  679. No)
  680. DEV_STATUS="UNKNOWN"
  681. DEV_STATUS_SELECTED="UNKNOWN"
  682. break
  683. ;;
  684. *)
  685. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  686. ;;
  687. esac
  688. done
  689. fi
  690. else
  691. DEV_STATUS=$DEV_STATUS_SELECTED
  692. fi
  693. #Prepare hex files folders
  694. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  695. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  696. fi
  697. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  698. #Check if exactly the same hexfile already exists
  699. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  700. echo ""
  701. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  702. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  703. if [ $OUTPUT == "1" ] ; then
  704. read -t 10 -p "Press Enter to continue..."
  705. fi
  706. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  707. echo ""
  708. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  709. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  710. if [ $OUTPUT == "1" ] ; then
  711. read -t 10 -p "Press Enter to continue..."
  712. fi
  713. fi
  714. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  715. echo ""
  716. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  717. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  718. if [ $OUTPUT == "1" ] ; then
  719. read -t 10 -p "Press Enter to continue..."
  720. fi
  721. fi
  722. #List some useful data
  723. echo "$(tput setaf 2)$(tput setab 7) "
  724. echo "Printer :" $PRINTER
  725. echo "Variant :" $VARIANT
  726. echo "Firmware :" $FW
  727. echo "Build # :" $BUILD
  728. echo "Dev Check :" $DEV_CHECK
  729. echo "DEV Status :" $DEV_STATUS
  730. echo "Motherboard:" $MOTHERBOARD
  731. echo "Languages :" $LANGUAGES
  732. echo "Hex-file Folder:" $OUTPUT_FOLDER
  733. echo "$(tput sgr0)"
  734. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  735. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  736. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  737. else
  738. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  739. if [ $OUTPUT == "1" ] ; then
  740. read -t 10 -p "Press Enter to continue..."
  741. fi
  742. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  743. fi
  744. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  745. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  746. # set FW_REPOSITORY
  747. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  748. #Prepare English only or multi-language version to be build
  749. if [ $LANGUAGES == "EN_ONLY" ]; then
  750. echo " "
  751. echo "English only language firmware will be built"
  752. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  753. echo " "
  754. else
  755. echo " "
  756. echo "Multi-language firmware will be built"
  757. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  758. echo " "
  759. fi
  760. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  761. #if [ $TARGET_OS == "windows" ]; then
  762. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  763. #fi
  764. #### End of Prepare building
  765. #### Start building
  766. export ARDUINO=$BUILD_ENV_PATH
  767. #echo $BUILD_ENV_PATH
  768. #export BUILDER=$ARDUINO/arduino-builder
  769. echo
  770. #read -t 5 -p "Press Enter..."
  771. echo
  772. echo "Start to build Prusa Firmware ..."
  773. echo "Using variant $VARIANT$(tput setaf 3)"
  774. if [ $OUTPUT == "1" ] ; then
  775. sleep 2
  776. fi
  777. #New fresh PF-Firmware-build
  778. if [ "$new_build_flag" == "1" ]; then
  779. rm -r -f $BUILD_PATH/* || exit 36
  780. fi
  781. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  782. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  783. echo "$(tput sgr 0)"
  784. if [ $LANGUAGES == "ALL" ]; then
  785. echo "$(tput setaf 2)"
  786. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  787. echo "$(tput sgr 0)"
  788. if [ $OUTPUT == "1" ] ; then
  789. sleep 2
  790. fi
  791. cd $SCRIPT_PATH/lang
  792. echo "$(tput setaf 3)"
  793. ./config.sh || exit 31
  794. echo "$(tput sgr 0)"
  795. # Check if previous languages and firmware build exist and if so clean them up
  796. if [ -f "lang_en.tmp" ]; then
  797. echo ""
  798. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  799. if [ $OUTPUT == "1" ] ; then
  800. read -t 10 -p "Press Enter to continue..."
  801. fi
  802. echo "$(tput setaf 3)"
  803. ./lang-clean.sh
  804. echo "$(tput sgr 0)"
  805. fi
  806. if [ -f "progmem.out" ]; then
  807. echo ""
  808. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  809. if [ $OUTPUT == "1" ] ; then
  810. read -t 10 -p "Press Enter to continue..."
  811. fi
  812. echo "$(tput setaf 3)"
  813. ./fw-clean.sh
  814. echo "$(tput sgr 0)"
  815. fi
  816. # build languages
  817. echo "$(tput setaf 3)"
  818. ./lang-build.sh || exit 32
  819. # build community languages
  820. ./lang-community.sh || exit 33
  821. # Combine compiled firmware with languages
  822. ./fw-build.sh || exit 33
  823. cp not_tran.txt not_tran_$VARIANT.txt
  824. cp not_used.txt not_used_$VARIANT.txt
  825. echo "$(tput sgr 0)"
  826. # Check if the motherboard is an EINSY and if so only one hex file will generated
  827. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  828. # If the motherboard is an EINSY just copy one hexfile
  829. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  830. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  831. # Make a copy of "lang.bin" for MK404 MK3 and MK3S
  832. if [ ! -z "$mk404_flag" ]; then
  833. cp -f lang.bin $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin
  834. fi
  835. # End of "lang.bin" for MK3 and MK3S copy
  836. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  837. else
  838. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  839. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  840. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  841. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  842. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  843. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  844. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  845. if [ $TARGET_OS == "windows" ]; then
  846. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  847. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  848. elif [ $TARGET_OS == "linux" ]; then
  849. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  850. if [ ! -z "$mk404_flag" ]; then
  851. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  852. fi
  853. # End of MK2, MK2.5, MK2.5S firmware copy
  854. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  855. fi
  856. fi
  857. # Cleanup after build
  858. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  859. echo "$(tput setaf 3)"
  860. ./fw-clean.sh || exit 34
  861. ./lang-clean.sh || exit 35
  862. echo "$(tput sgr 0)"
  863. fi
  864. else
  865. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  866. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  867. fi
  868. # Cleanup Firmware
  869. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  870. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  871. fi
  872. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  873. then
  874. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  875. fi
  876. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  877. then
  878. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  879. fi
  880. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  881. then
  882. rm $SCRIPT_PATH/lang/not_tran.txt
  883. fi
  884. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  885. then
  886. rm $SCRIPT_PATH/lang/not_used.txt
  887. fi
  888. #New fresh PF-Firmware-build
  889. if [ "$new_build_flag" == "1" ]; then
  890. rm -r -f $BUILD_PATH/* || exit 36
  891. fi
  892. # Restore files to previous state
  893. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  894. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  895. if [ ! -z "$BUILD_ORG" ] ; then
  896. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  897. fi
  898. echo $MULTI_LANGUAGE_CHECK
  899. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  900. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  901. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  902. if [ $OUTPUT == "1" ] ; then
  903. sleep 5
  904. fi
  905. done
  906. # Switch to hex path and list build files
  907. cd $SCRIPT_PATH
  908. echo "$(tput setaf 2) "
  909. echo " "
  910. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  911. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  912. #### End building
  913. #### MK404 Simulator
  914. # Check/compile MK404 sim
  915. if [ ! -z "$mk404_flag" ]; then
  916. ./MK404-build.sh -c1
  917. # For Prusa MK2, MK2.5/S
  918. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  919. PRINTER="${PRINTER}_mR13"
  920. else
  921. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  922. PRINTER="${PRINTER}MMU2"
  923. fi
  924. fi
  925. # Run MK404 with grafics
  926. if [ ! -z "$graphics_flag" ]; then
  927. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  928. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "lite" ]]; then
  929. MK404_options="${MK404_options}lite"
  930. elif [[ "$graphics_flag" == "2" || "$graphics_flag" == "fancy" ]]; then
  931. MK404_options="${MK404_options}fancy"
  932. else
  933. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  934. fi
  935. fi
  936. # Output some useful data
  937. echo "Printer: $PRINTER"
  938. echo "Options: $MK404_options"
  939. # Change to MK404 build folder
  940. cd ../MK404/master/build
  941. # Copy language bin file for MK3 and MK3S to xflash
  942. # if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
  943. # echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${PRINTER}_xflash.bin'"
  944. # dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${PRINTER}_xflash.bin
  945. # dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${PRINTER}_xflash.bin conv=notrunc
  946. # fi
  947. #Decide which hex file to use EN_ONLY or Multi language
  948. if [ "$LANGUAGES" == "ALL" ]; then
  949. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  950. else
  951. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  952. fi
  953. # Start MK404
  954. # default with serial output and terminal to manipulate it via terminal
  955. ./MK404 Prusa_$PRINTER -s --terminal $MK404_options -f $MK404_firmware_file
  956. fi
  957. #### End of MK404 Simulator